package com.izouma.dingdong.web.backstage;

import com.izouma.dingdong.web.BaseController;
import com.izouma.dingdong.domain.backstage.MerchantNature;
import com.izouma.dingdong.service.backstage.MerchantNatureService;
import com.izouma.dingdong.dto.PageQuery;
import com.izouma.dingdong.exception.BusinessException;
import com.izouma.dingdong.repo.backstage.MerchantNatureRepo;
import com.izouma.dingdong.utils.ObjUtils;
import com.izouma.dingdong.utils.excel.ExcelUtils;

import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/merchantNature")
@AllArgsConstructor
public class MerchantNatureController extends BaseController {
    private MerchantNatureService merchantNatureService;
    private MerchantNatureRepo merchantNatureRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public MerchantNature save(@RequestBody MerchantNature record) {
        if (record.getId() != null) {
            MerchantNature orig = merchantNatureRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return merchantNatureRepo.save(orig);
        }
        return merchantNatureRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/all")
    public Page<MerchantNature> all(PageQuery pageQuery) {
        return merchantNatureRepo.findAll(toSpecification(pageQuery,MerchantNature.class), toPageRequest(pageQuery));
    }

    @GetMapping("/get/{id}")
    public MerchantNature get(@PathVariable Long id) {
        return merchantNatureRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        merchantNatureRepo.deleteById(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<MerchantNature> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

